n = 0
M = {}
G = []
edges = []
visited = []
wrank = []
S = []

def dfs_visit(v):
  global visited, wrank, S
  visited[v] = True
  for x in G[v]:
    if not visited[x]:
      dfs_visit(x)
  wrank[v] = len(S)
  S.append(v)
  
def cycles():
  global G, wrank, n;
  for v in range(1,n+1):
    for x in G[v]:
      if wrank[x] > wrank[v]:
        return True;
  return False
  
def gaps():
  for r in range(n-1,0,-1):
    v, w = S[r], S[r-1]
    if w not in G[v]:
      return True
  return False
  
m = int(input())
for _ in range(m):
  sa, sb = input().split()
  if sa in M:
    a = M[sa]
  else:
    n += 1
    a = n
    M[sa] = a
  if sb in M:
    b = M[sb]
  else:
    n += 1
    b = n
    M[sb] = b
  edges.append([a, b])
  
for _ in range(n+1):
  G.append([])
  visited.append(False)
  wrank.append(-1)
  
for e in edges:
  G[e[0]].append(e[1])

'''
for v in range(1,n):
  print(v, ':', end='')
  for x in G[v]:
    print(x, end='')
  print()
'''
for v in range(1,n+1):
  if not visited[v]:
    dfs_visit(v)
'''
for x in S:
  print(x, wrank[x])
'''
if cycles():
  print('NIE')
elif gaps():
  print('???')
else:
  print('OK')
  

